/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package vista;

import controlador.ListaEnlazada;
import controlador.tablaPersona;
import controlador.utiles.TipoOrdenacion;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import modelo.persona;

/**
 *
 * @author Ronald Cuenca, Andres Guachon
 */
public class ventana extends javax.swing.JFrame {
    ListaEnlazada<persona> lista1 = new ListaEnlazada<>();
    tablaPersona tp = new tablaPersona();
    
    /**
     * Creates new form ventana
     */
    public ventana() {
        initComponents();
        setLocationRelativeTo(null);
    }
    
    public void cargarTabla(){
        tp.setLista(lista1);
        jTable1.setModel(tp);
        jTable1.updateUI();
    }
    
    private static boolean isNumeric(String cadena){
	try {
		Double.parseDouble(cadena);
		return true;
	} catch (NumberFormatException nfe){
		return false;
	}
}

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox<>();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jComboBox3 = new javax.swing.JComboBox<>();
        jTextField1 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jComboBox4 = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButton2.setText("Llenar");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jLabel1.setText("Ordenar:");

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "ASCENDENTE", "DESCENDENTE" }));

        jLabel2.setText("Atributo:");

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "ID", "Nombre", "Edad" }));

        jButton1.setText("Ordenar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton3.setText("Vaciar");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jLabel3.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        jLabel3.setText("Busqueda:");

        jLabel4.setText("Atributo:");

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "IDPersona", "nombre", "edad" }));

        jButton4.setText("Buscar");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel5.setText("Método:");

        jComboBox4.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Shell", "QuickSort" }));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jButton4)
                .addGap(148, 148, 148))
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 329, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(43, 43, 43)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jComboBox4, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                    .addComponent(jButton2)
                                    .addGap(34, 34, 34))))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(31, 31, 31)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jButton3)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(54, 54, 54)
                                .addComponent(jButton1)))))
                .addContainerGap(22, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addGap(42, 42, 42)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jLabel5)
                    .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(15, 15, 15)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 275, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel3)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton4)
                .addContainerGap(18, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        lista1 = lista1.llenarLista();
        cargarTabla();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        if (jComboBox4.getSelectedItem().equals("Shell")) {
        if (jComboBox1.getSelectedItem().equals("ASCENDENTE")&&jComboBox2.getSelectedItem().equals("ID")) {
            try {
                long inicio = System.currentTimeMillis();
                lista1.shell("IDPersona", TipoOrdenacion.ASCENDENTE);
                cargarTabla();
                long fin = System.currentTimeMillis();
                JOptionPane.showMessageDialog(null, "Tiempo total: "+((double) (fin - inicio) / 1000)+"s");
            } catch (Exception e) {
                System.out.println(e);
            }
        }
        if (jComboBox1.getSelectedItem().equals("DESCENDENTE")&&jComboBox2.getSelectedItem().equals("ID")) {
            try {
                long inicio = System.currentTimeMillis();
                lista1.shell("IDPersona", TipoOrdenacion.DESCENDENTE);
                cargarTabla();
                long fin = System.currentTimeMillis();
                JOptionPane.showMessageDialog(null, "Tiempo total: "+((double) (fin - inicio) / 1000)+"s");
            } catch (Exception e) {
                System.out.println(e);
            }
        }
        if (jComboBox1.getSelectedItem().equals("ASCENDENTE")&&jComboBox2.getSelectedItem().equals("Nombre")) {
            try {
                long inicio = System.currentTimeMillis();
                lista1.shell("nombre", TipoOrdenacion.ASCENDENTE);
                cargarTabla();
                long fin = System.currentTimeMillis();
                JOptionPane.showMessageDialog(null, "Tiempo total: "+((double) (fin - inicio) / 1000)+"s");
            } catch (Exception e) {
                System.out.println(e);
            }
        }
        if (jComboBox1.getSelectedItem().equals("DESCENDENTE")&&jComboBox2.getSelectedItem().equals("Nombre")) {
            try {
                long inicio = System.currentTimeMillis();
                lista1.shell("nombre", TipoOrdenacion.DESCENDENTE);
                cargarTabla();
                long fin = System.currentTimeMillis();
                JOptionPane.showMessageDialog(null, "Tiempo total: "+((double) (fin - inicio) / 1000)+"s");
            } catch (Exception e) {
                System.out.println(e);
            }
        }
        if (jComboBox1.getSelectedItem().equals("ASCENDENTE")&&jComboBox2.getSelectedItem().equals("Edad")) {
            try {
                long inicio = System.currentTimeMillis();
                lista1.shell("edad", TipoOrdenacion.ASCENDENTE);
                cargarTabla();
                long fin = System.currentTimeMillis();
                JOptionPane.showMessageDialog(null, "Tiempo total: "+((double) (fin - inicio) / 1000)+"s");
            } catch (Exception e) {
                System.out.println(e);
            }
        }
        if (jComboBox1.getSelectedItem().equals("DESCENDENTE")&&jComboBox2.getSelectedItem().equals("Edad")) {
            try {
                long inicio = System.currentTimeMillis();
                lista1.shell("edad", TipoOrdenacion.DESCENDENTE);
                cargarTabla();
                long fin = System.currentTimeMillis();
                JOptionPane.showMessageDialog(null, "Tiempo total: "+((double) (fin - inicio) / 1000)+"s");
            } catch (Exception e) {
                System.out.println(e);
            }
        }
        }else if (jComboBox4.getSelectedItem().equals("QuickSort")) {
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("ID")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortID(lista1, 0, lista1.getSize()-1, TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("ID")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortID(lista1, 0, lista1.getSize()-1, TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("Nombre")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortNombre(lista1, 0, lista1.getSize()-1, TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("Nombre")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortNombre(lista1, 0, lista1.getSize()-1, TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("Edad")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortedad(lista1, 0, lista1.getSize()-1, TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("Edad")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortedad(lista1, 0, lista1.getSize()-1, TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        lista1.vaciar();
        cargarTabla();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        if (jComboBox3.getSelectedItem().equals("IDPersona")) {
            try {
                if (isNumeric(jTextField1.getText())) {
                    if (lista1.binaria(Integer.parseInt(jTextField1.getText()), lista1, "IDPersona")==true) {
                    JOptionPane.showMessageDialog(null, "Dato Encontrado");
                }else{
                        JOptionPane.showMessageDialog(null, "Dato No Encontrado");
                    }
                }else{
                    JOptionPane.showMessageDialog(null, "Ingrese valor numerico");
                }
        } catch (Exception ex) {
                System.out.println(ex);
        }
        }
            if (jComboBox3.getSelectedItem().equals("edad")) {
            try {
            if (isNumeric(jTextField1.getText())) {
                    if (lista1.binaria(Integer.parseInt(jTextField1.getText()), lista1, "edad")==true) {
                    JOptionPane.showMessageDialog(null, "Dato Encontrado");
                }else{
                        JOptionPane.showMessageDialog(null, "Dato No Encontrado");
                    }
                }else{
                    JOptionPane.showMessageDialog(null, "Ingrese valor numerico");
                }
        } catch (Exception ex) {
                System.out.println(ex);
        }
            }
            if (jComboBox3.getSelectedItem().equals("nombre")) {
            try {
                Object a = jTextField1.getText().toString();
            if (lista1.binaria(a, lista1, "nombre")==true) {
                    JOptionPane.showMessageDialog(null, "Dato Encontrado");
                }else{
                        JOptionPane.showMessageDialog(null, "Dato No Encontrado");
                    }
        } catch (Exception ex) {
                System.out.println(ex);
        }
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ventana().setVisible(true);
            }
        });
    }
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JComboBox<String> jComboBox2;
    private javax.swing.JComboBox<String> jComboBox3;
    private javax.swing.JComboBox<String> jComboBox4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
